<?php
namespace Elbotrade\Bundle\ContentBundle\Controller;

use Symfony\Component\HttpFoundation\Request;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;

class CertificateBackendController extends CertificateController
{

    /**
     * @Route("/elbotrade/certificate/backend/list", name="elbotrade_certificate_backend_list")
     * @Template()
     */
    public function indexAction()
    {

        return parent::indexAction(); // TODO: Change the autogenerated stub
    }

    /**
     * @Route("/elbotrade/certificate/backend/show/{id}", name="elbotrade_certificate_backend_show")
     * @Template()
     */
    public function showAction($id)
    {
        return parent::showAction($id); // TODO: Change the autogenerated stub
    }

    /**
     * @param Request $request
     * @return array
     * @Route("/elbotrade/certificate/backend/create", name="elbotrade_certificate_backend_create")
     * @Template();
     */
    public function createAction(Request $request)
    {

        $certificateManager = $this->get('elbotrade.content_bundle.certificate_manager');

        $certificate = $certificateManager->createCertificate();

        $form = $this->createForm(
            $this->get('elbotrade_content.certificate.form.type'), null, ['action' => $this->generateUrl('elbotrade_certificate_backend_create')]
        );

        if ($request->isMethod(Request::METHOD_POST)) {
            $certificateManager = $this->get('elbotrade.content_bundle.certificate_manager');
            if ($certificateId = $certificateManager->handleCertificateForm($form, $certificate, $request)) {
                $response = $this->redirect($this->generateUrl('elbotrade_certificate_backend_list', ['id' => $certificateId]));
                return $response;
            }
        }

        $form->setData($certificate);

        return [
            'form' => $form->createView(),
        ];

    }

    /**
     * @param Request $request
     * @param $id
     * @Route("/elbotrade/certificate/backend/update/{id}", name="elbotrade_certificate_backend_update")
     * @Template()
     * @return array|\Symfony\Component\HttpFoundation\RedirectResponse
     */
    public function updateAction(Request $request, $id)
    {

        $certificateFinder = $this->get('elbotrade.content_bundle.certificate_finder');

        $certificate = $certificateFinder->findCertificate($id);

        $form = $this->createForm(
            $this->get('elbotrade_content.certificate.form.type'), null, ['action' => $this->generateUrl('elbotrade_certificate_backend_update', ['id' => $id])]
        );

        if ($request->isMethod(Request::METHOD_POST)) {
            $certificateManager = $this->get('elbotrade.content_bundle.certificate_manager');
            if ($certificateId = $certificateManager->handleCertificateForm($form, $certificate, $request)) {
                $response = $this->redirect($this->generateUrl('elbotrade_certificate_backend_show', ['id' => $certificateId]));
                return $response;
            }
        }

        $form->setData($certificate);

        return [
            'form' => $form->createView(),
        ];

    }

    /**
     * @Route("/elbotrade/certificate/backend/delete/{id}", name="elbotrade_certificate_backend_delete")
     */
    public function deleteAction($id)
    {

        $certificate = $this->get('elbotrade.content_bundle.certificate_finder')->findCertificate($id);

        $this->getDoctrine()->getManager()->remove($certificate);
        $this->getDoctrine()->getManager()->flush();

        $flashService = $this->get('elbotrade_product.services.flash_service');

        $flashService->setFlash('success', 'Certificate Deleted');

        return $this->redirect($this->generateUrl('elbotrade_certificate_backend_list'));
    }
}